/*
 * hello-args.c --
 *
 *      This program uses the stdio library to print a short messages.
 *	The messages depend on the arguments provided to the program.
 *      Note that we check whether buffered output stream managed to
 *	write the messages.
 */

#include <stdio.h>
#include <stdlib.h>

static void hello(char *thingy)
{
    if (printf("Hello %s!\n", thingy) < 0) {
        perror("printf");
        exit(EXIT_FAILURE);
    }
}

int main(int argc, char *argv[])
{
    if (argc == 1) {
        hello("world");
    } else {
        for (int i = 1; i < argc; i++) {
            hello(argv[i]);
        }
    }

    if (fflush(stdout) == EOF) {
        perror("fflush");
        return EXIT_FAILURE;
    }
    return EXIT_SUCCESS;
}
